﻿using HeuristicLab.Algorithms.PushGP.Stack;

namespace HeuristicLab.Algorithms.PushGP.Expressions
{
    public class CodeDefineExpression : Expression
    {
        public CodeDefineExpression() : base(OpCode.CodeDefine)
        { }

        public override void Eval(IInterpreterService interpreterService)
        {
            Define(
                interpreterService.CodeStack,
                interpreterService.NameStack,
                interpreterService.CustomExpressions,
                value => new ExecPushExpression(value));

            // as the interpreter does not pop code expressions
            interpreterService.CodeStack.Pop();
        }
    }
}
