﻿using HeuristicLab.Algorithms.PushGP.Stack;

namespace HeuristicLab.Algorithms.PushGP.Expressions
{
    public class ExecYExpression : Expression
    {
        public ExecYExpression() : base(OpCode.ExecY)
        { }

        public override void Eval(IInterpreterService interpreterService)
        {
            // not enough arguments on stack
            if (interpreterService.ExecStack.Count == 0)
                return;

            var expandExpression = new ExecExpandExpression(new[]
            {
                interpreterService.ExecStack.Top,
                new ExecYExpression()
            });

            interpreterService.ExecStack.Insert(interpreterService.ExecStack.Count - 1, expandExpression);
        }
    }
}
