﻿namespace HeuristicLab.Algorithms.PushGP.Generators
{
    public class Configuration
    {
        /// <summary>
        /// The minimum INTEGER that will be produced as an ephemeral random INTEGER constant or from a call to INTEGER.RAND.
        /// </summary>
        public long MinRandomInteger { get; set; } = long.MinValue;

        /// <summary>
        /// The maximum INTEGER that will be produced as an ephemeral random INTEGER constant or from a call to INTEGER.RAND.
        /// </summary>
        public long MaxRandomInteger { get; set; } = long.MaxValue;

        /// <summary>
        /// The minimum FLOAT that will be produced as an ephemeral random FLOAT constant or from a call to FLOAT.RAND.
        /// </summary>
        public double MinRandomFloag { get; set; } = double.MinValue;

        /// <summary>
        /// The maximum FLOAT that will be produced as an ephemeral random FLOAT constant or from a call to FLOAT.RAND.
        /// </summary>
        public double MaxRandomFloag { get; set; } = double.MaxValue;

        /// <summary>
        /// The probability that the selection of the ephemeral
        /// random NAME constant for inclusion in randomly generated code will produce a new name
        /// (rather than a name that was previously generated).
        /// </summary>
        public double NewErcNameProbability { get; set; } = 0.5;
    }
}
