﻿using System;
using System.Threading;

namespace HeuristicLab.Algorithms.PushGP
{
    public static class StaticRandom
    {
        static int seed = Environment.TickCount;

        static readonly ThreadLocal<Random> random =
            new ThreadLocal<Random>(() => new Random(Interlocked.Increment(ref seed)));

        public static int Next(int minValue = int.MinValue, int maxValue = int.MaxValue)
        {
            return random.Value.Next(minValue, maxValue);
        }

        public static double NextDouble => random.Value.NextDouble();
    }
}
